﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.Serialization.Formatters.Binary;

namespace GraphicsLearn
{
    public partial class Form3 : Form
    {
        Color currentcolor = Color.Red;
        SelectedShape currentshape = SelectedShape.Circle;
        List<SharpData> datalist = new List<SharpData>();
        public Form3()
        {
            InitializeComponent();
        }

        private void tsmselectcolor_Click(object sender, EventArgs e)
        {
            ColorDialog colordlg = new ColorDialog();
            if (colordlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                currentcolor = colordlg.Color;
            }
        }

        private void tsmselectshape_Click(object sender, EventArgs e)
        {
            ShapePickerDialog shapedlg = new ShapePickerDialog();
            if (shapedlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                currentshape = shapedlg.Selectshape;
            }
        }

        private void Form3_MouseDown(object sender, MouseEventArgs e)
        {
            SharpData sd = new SharpData();
            sd.ShapeType = currentshape;
            sd.Color = currentcolor;
            sd.UpperLeftPoint = new Point(e.X, e.Y);

            datalist.Add(sd);

            Invalidate();
        }

        private void Form3_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;

            foreach (SharpData s in datalist)
            {
                if (s.ShapeType == SelectedShape.Rectangle)
                {
                    g.FillRectangle(new SolidBrush(s.Color), s.UpperLeftPoint.X, s.UpperLeftPoint.Y, 20, 20);
                }
                else
                {
                    g.FillEllipse(new SolidBrush(s.Color), s.UpperLeftPoint.X, s.UpperLeftPoint.Y, 20, 20);
                }
            }
        }

        private void tsmClearSharp_Click(object sender, EventArgs e)
        {
            datalist.Clear();

            Invalidate();
        }

        private void tsmFileSave_Click(object sender, EventArgs e)
        {
            SaveFileDialog savedlg = new SaveFileDialog();
            savedlg.InitialDirectory = "D:\\";
            savedlg.Filter = "Sharp文件(*.sharp)|*.sharp";
            savedlg.RestoreDirectory = true;
            savedlg.FileName = "MySharps";
            if (savedlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Stream stream = savedlg.OpenFile();
                if (stream != null)
                {
                    BinaryFormatter formatter = new BinaryFormatter();
                    formatter.Serialize(stream, datalist);
                    stream.Close();
                }
            }
        }

        private void tsmFileOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog opendlg = new OpenFileDialog();
            opendlg.InitialDirectory = "D:\\";
            opendlg.Filter = "Sharp文件(*.sharp)|*.sharp";
            opendlg.RestoreDirectory = true;
            opendlg.FileName = "MySharps";
            if (opendlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                Stream stream = opendlg.OpenFile();
                BinaryFormatter formatter = new BinaryFormatter();
                datalist = (List<SharpData>)formatter.Deserialize(stream);
                stream.Close();
                Invalidate();
            }
        }
    }
}
