﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GraphicsLearn
{
    public partial class Form4 : Form
    {
        // member fields 
        private readonly Point rectangleTopLeft = new Point(0, 0);
        private readonly Size rectangleSize = new Size(200, 200);
        private readonly Point ellipseTopLeft = new Point(50, 200);
        private readonly Size ellipseSize = new Size(200, 150);
        private readonly Pen bluePen = new Pen(Color.Blue, 3);
        private readonly Pen redPen = new Pen(Color.Red, 2);
        public Form4()
        {
            InitializeComponent();
            this.AutoScrollMinSize = new Size(250, 350);
            this.TopMost = true;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            Graphics dc = e.Graphics;
            Size scrollOffset = new Size(this.AutoScrollPosition);
            Rectangle rectangleArea = new Rectangle
            (rectangleTopLeft + scrollOffset, rectangleSize);
            Rectangle ellipseArea = new Rectangle
            (ellipseTopLeft + scrollOffset, ellipseSize);
            dc.DrawRectangle(bluePen, rectangleArea);
            dc.DrawEllipse(redPen, ellipseArea);
        }
    }
}
